#*** File tres/Src/t_tpreamp1.x
#*** September 27, 2007
#*** By Doug Mink

include	<mach.h>
include	<imhdr.h>
include	<gset.h>

# TPREAMP1 -- Fix one TRES preamp

procedure t_tpreamp1

int	i, ncol, nrow, npix
int	ifold, nfold, ncfold, nrfold, dispaxis, ip, x2, y2, step
pointer imi, imo, sp, inbuf, outbuf, imin, imout, inpath, outpath
char    hstring[SZ_LINE]
char    dstring[SZ_LINE]
char	imsect[SZ_LINE]
int	nlen1,nlen2,nplen1,nplen2, lpath
int	xin1,xin2,yin1,yin2,xout1,xout2,yout1,yout2
bool	verbose, clgetb()

int	clgeti(), strlen()
int	imgs2r(), imgs2i()
int	imps2r(), imps2i()
pointer	immap()

begin
	call smark (sp)
	call salloc (imin,   SZ_FNAME,  TY_CHAR)
	call salloc (inpath,   SZ_PATHNAME,  TY_CHAR)
	call salloc (imout,   SZ_FNAME,  TY_CHAR)
	call salloc (outpath,   SZ_PATHNAME,  TY_CHAR)
	verbose = clgetb ("verbose")

	# Get the image input name.
	call clgstr ("imin", Memc[imin], SZ_LINE)
	call clgstr ("indir", Memc[inpath], SZ_LINE)
	lpath = strlen (Memc[inpath])
	if (lpath > 0) {
	    if (Memc[inpath+lpath-1] != '/') {
		Memc[inpath+lpath] = '/'
		Memc[inpath+lpath+1] = EOS
		}
	    call strcat (Memc[imin], Memc[inpath], SZ_FNAME)
	    }
	else
	    call strcpy (Memc[imin], Memc[inpath], SZ_FNAME)
	imi = immap (Memc[inpath], READ_ONLY, 0)

	# Get image dimensions
	nlen1 = IM_LEN(imi,1)
	nlen2 = IM_LEN(imi,2)
	nplen1 = IM_PHYSLEN(imi,1)
	nplen2 = IM_PHYSLEN(imi,2)
	ncol = nlen1
	nrow = nlen2
	xin1 = 1
	yin1 = 1
	xout1 = 1
	yout1 = 1

	if (verbose) {
	    call printf ("TPREAMP1: %d x %d input image %s opened\n")
		call pargi (ncol)
		call pargi (nrow)
		call pargstr (Memc[imin])
	    call flush (STDOUT)
	    }

	# Output filename can be either input or created
	call clgstr ("imout", Memc[imout], SZ_LINE)
	if (Memc[imout] == EOS) {
	    call strcpy (Memc[imin],Memc[imout],SZ_LINE)
	    call strcat ("_pre", Memc[imout], SZ_LINE)
	    }
	call clgstr ("outdir", Memc[outpath], SZ_LINE)
	lpath = strlen (Memc[outpath])
	if (lpath > 0) {
	    if (Memc[outpath+lpath-1] != '/') {
		Memc[outpath+lpath] = '/'
		Memc[outpath+lpath+1] = EOS
		}
	    call strcat (Memc[imout], Memc[outpath], SZ_FNAME)
	    }
	else
	    call strcpy (Memc[imout], Memc[outpath], SZ_FNAME)

	# Open output image
	imo = immap (Memc[outpath], NEW_COPY, imi)

	# Reset input file dimensions
	IM_LEN(imi,1) = nlen1
	IM_LEN(imi,2) = nlen2
	IM_PHYSLEN(imi,1) = nplen1
	IM_PHYSLEN(imi,2) = nplen2
	npix = nplen1 * nplen2

	#  Put date into HISTORY
	call logtime (dstring, SZ_LINE)
	call sprintf (hstring,SZ_LINE,"Preamp fixed by TPREAMP1 %s")
	    call pargstr (dstring)
	call imputh (imo, "HISTORY", hstring)

	# Fill in folded image
	switch (IM_PIXTYPE(imi)) {
	case TY_SHORT, TY_USHORT, TY_INT, TY_LONG:
	    do j = 1, nplen1 {
		inbuf = imgs2i (imi, xin1,xin2,yin1,yin2)
		outbuf = imps2i (imo, xout1,xout2,yout1,yout2)
		npix = (xin2 - xin1 + 1) * (yin2 - yin1 + 1)
		call amovi (Memi[inbuf],Memi[outbuf],npix)
		call imflsi (imo)
		if (dispaxis == 1) {
		    xin1 = xin1 + ncfold
		    xin2 = xin2 + ncfold
		    if (xin2 > nlen1) {
			xout2 = xout2 - (xin2 - nlen1)
			xin2 = nlen1
			}
		    yout1 = yout1 - nrow
		    yout2 = yout2 - nrow
		    }
		else {
		    yin1 = yin1 + nrfold
		    yin2 = yin2 + nrfold
		    if (yin2 > nlen2) {
			yout2 = yout2 - (yin2 - nlen2)
			yin2 = nlen2
			}
		    xout1 = xout1 + ncol
		    xout2 = xout2 + ncol
		    }
		}

	#  Floating point data

	default:
	    do i = 1, npix {
		inbuf = imgs2r (imi, xin1,xin2,yin1,yin2)
		outbuf = imps2r (imo, xout1,xout2,yout1,yout2)
		npix = (xin2 - xin1 + 1) * (yin2 - yin1 + 1)
		call amovr (Memr[inbuf],Memr[outbuf],npix)
		call imflsr (imo)
		if (dispaxis == 1) {
		    xin1 = xin1 + ncfold
		    xin2 = xin2 + ncfold
		    if (xin2 > nlen1) {
			xout2 = xout2 - (xin2 - nlen1)
			xin2 = nlen1
			}
		    yout1 = yout1 - nrow
		    yout2 = yout2 - nrow
		    }
		else {
		    yin1 = yin1 + nrfold
		    yin2 = yin2 + nrfold
		    if (yin2 > nlen2) {
			yout2 = yout2 - (yin2 - nlen2)
			yin2 = nlen2
			}
		    xout1 = xout1 + ncol
		    xout2 = xout2 + ncol
		    }
		}
	}


	# Shutdown.
	call imunmap (imi)
	call imunmap (imo)
	call sfree (sp)
end

# Feb 11 1993	New program

# Oct 30 1995	Add directories as parameters
# Oct 30 1995	Start at upper left instead of lower left
